package;

import sys.io.File;
import sys.io.FileOutput;
import haxe.io.Bytes;
import haxe.Http;

class FileDownloader {
   var request:Http;

   var originalUrl:String;
   var url:String;

   var targetSize:Null<Int>;

   var targetFile:String;

   var file:FileOutput;

   public function new(url:String, toFile:String) {
      this.originalUrl = url;
      this.url = url;
      this.targetFile = toFile;
      this.file = File.write(targetFile, true);
      this.request = new Http(url);
   }

   public function download():Void {
      var request = new Http(this.url);
      // request.setHeader('')
      request.onBytes = (bytes:Bytes) -> {
         // trace(bytes.length);
         file.write(bytes);
         // trace('onbytes: ${bytes.toHex()}');
      };
      request.onData = (data:String) -> {
         // trace('ondata: ${data}');
      };
      request.onError = (err:String) -> {
         // trace('onerror: ${err}');
      };
      request.onStatus = (status:Int) -> {
         // trace('onstatus: ${status}');
         if (status == 302) {
            // trace();
            request.url = request.responseHeaders.get('Location');
            request.request();
         } else {
            // trace(request.responseHeaders);
            targetSize = Std.parseInt(request.responseHeaders.get('Content-Length'));
         }
      };
      request.request();
      file.close();
      // trace('downloaded ${bytesSoFar} bytes in ${bytePackets} chunks');
   }
}
