package interfaces;

enum Mode {
   /**
      prints each char on a line as its code + pretty printed variant
   **/
   PrintCodes;

   /**
      prints the pretty printed variant of each character
   **/
   PrintText;

   /**
      prints entire sequences on a line
   **/
   PrintSequences;
}

class DebugInterface extends AbstractInterface {
   public function new() {}

   function print():Void {
      ANSI.clearScreen();
      ANSI.cursorPosition = {row: 0, column: 0};

      Sys.print('Godot Manager Key Debug Interface\n');
      Sys.print('Press a button to display it, or its escape sequence\n');
      // Sys.print('Press the space bar to clear\n');
   }

   override function handleInput():Void {
      while (true) {
         var char = Sys.getChar(false);

         switch (char) {
            // spacebar clears the output
            case ' '.code:
               Sys.print('\x1b[\x00;${String.fromCharCode(5)};${String.fromCharCode(5)};${String.fromCharCode(6)};${String.fromCharCode(6)}$$x');
            // break;
            // ctrl + c -> exit
            case 3:
               hide();
               break;
            // print the number
            default:
               // Sys.println('${char} - ${ANSI.prettyPrintableCharFromCode(char)}');
               Sys.println(StringTools.rpad('', 'a', ANSI.terminalSize.width - 1));
         }
      }
   }
}
