package interfaces;

import interfaces.ListEntry;

enum SelectorResult {
   Selected(entry:ListEntry);
   Aborted();
}

class SelectorListEntry extends BasicListEntry {
   public var value:String;

   var selector:SelectorInterface;

   public function new(list:SelectorInterface, name:String, value:String) {
      super(list, name);
      this.selector = list;
      this.value = value;
   }

   public override function keyEnter():Void {
      selector.madeSelection = true;
      selector.hide();
   }
}

/**
   An interface to pick a single option from a list of options
**/
class SelectorInterface extends ListInterface {
   public var madeSelection = false;

   public function new() {
      super();
   }

   public function select():SelectorResult {
      show();
      if (!madeSelection)
         return Aborted;
      return Selected(currentlySelected);
   }
}
